//
//  YunDanXiangQingViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/30.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class YunDanXiangQingViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource{
    
    
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var btmView: UIView!
    let btnTitleArr = ["1","2","3"]
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "运单详情"
        self.view.addSubview(navbar)
        listView.separatorStyle = .none
        SetTopFrameView(view: listView, btmView: btmView)
        listView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
        listView.register(UINib(nibName: "XiaDanCGDiZhiCell", bundle: nil), forCellReuseIdentifier: "XiaDanCGDiZhiCell")
        listView.register(UINib(nibName: "JiBenXinXiCell", bundle: nil), forCellReuseIdentifier: "JiBenXinXiCell")
        
        for i in 0 ..< btnTitleArr.count {
            let btn = UIButton()
            let idx = btnTitleArr.count-i-1
            btn.tag = idx
            btn.setTitle(btnTitleArr[idx], for: .normal)
            btn.titleLabel?.font = UIFont.systemFont(ofSize: 15)
            btn.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
            btn.layer.cornerRadius = 15
            btn.layer.masksToBounds = true
            btn.layer.borderColor = UIColor(named: "蓝色字体颜色")?.cgColor
            btn.layer.borderWidth = 1
            if btn.tag == 0 {
                btn.backgroundColor = UIColor(named: "蓝色字体颜色")
                btn.setTitleColor(UIColor.white, for: .normal)
            }
            btn.addTarget(self, action: #selector(btnClick(sender:)), for: .touchUpInside)
            btmView.addSubview(btn)
            let x = -i * 105 - 15
            btn.snp.makeConstraints { (make) in
                make.width.equalTo(90)
                make.height.equalTo(30)
                make.top.equalTo(9.5)
                make.right.equalTo(x)
            }
            
        }
        
    }
    
    @objc func btnClick(sender:UIButton){
        print(sender.tag)
    }
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        switch section {
        case 0:return 0.001
        default:
            return 36
        }
    }
    
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        switch section {
        case 0:return UIView()
        default:
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 36))
            view.backgroundColor = UIColor.white
            let lbl = UILabel()
            lbl.text = "货物信息"
            lbl.textColor = UIColor(named: "标题字颜色")
            lbl.font = UIFont.boldSystemFont(ofSize: 15)
            view.addSubview(lbl)
            lbl.snp.makeConstraints { (make) in
                make.top.left.right.equalTo(15)
                make.height.equalTo(21)
            }
            return view
        }
    }
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        return UIView()
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        return 10
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return 2
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if section == 0 {
            return 7
        }
        return 9
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 0 {
            switch indexPath.row {
            case 0:
                return 84.5
            case 1,2:
                return 64.5
            default:
                return 30
            }
        }
        return 30
    }
    let p2Arr = ["0","0","0","关联平台：","关联订单号：","运费：","运费支付方式："]
    let p3Arr = ["寄托物：","总重量：","总件数：","体积：","温控范围：","寄件方式：","派件方式：","保价（元人民币）：","备注："]
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.section == 0 {
            switch indexPath.row {
            case 0:
                let cell = tableView.dequeueReusableCell(withIdentifier: "JiBenXinXiCell") as! JiBenXinXiCell
                return cell
            case 1,2:
                let cell = tableView.dequeueReusableCell(withIdentifier: "XiaDanCGDiZhiCell") as! XiaDanCGDiZhiCell
                cell.statusLbl.text = "寄"
                if indexPath.row == 2 {
                    cell.statusLbl.backgroundColor = UIColor(named: "企业、预售字体")
                    cell.statusLbl.text = "收"
                }
                return cell
            default:
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
                cell.nameLbl.text = p2Arr[indexPath.row]
                cell.textTF.text = p2Arr[indexPath.row]
                cell.textTF.isUserInteractionEnabled = false
                cell.line.isHidden = true
                return cell
            }
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
        cell.nameLbl.text = p3Arr[indexPath.row]
        cell.textTF.text = p3Arr[indexPath.row]
        cell.textTF.isUserInteractionEnabled = false
        cell.line.isHidden = true
        return cell
    }
}
