//
//  PinPaiListViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/5/8.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol PinPaiListViewControllerDelegate {
    func blackSelectPinPaiData(sender:GeneralInfoBrandModel)
}
class PinPaiListViewController: BaseViewController,UISearchBarDelegate,SearchBarViewDelegate,UITableViewDelegate,UITableViewDataSource,TitleAndSelectCellDelegate{
    var dataModelArray : Array<GeneralInfoBrandModel>? = []
    var isSelectData : Bool = false
    var delegate : PinPaiListViewControllerDelegate?
    @IBOutlet weak var sureTop: NSLayoutConstraint!
    @IBOutlet weak var tableBottom: NSLayoutConstraint!
    @IBOutlet weak var sureLbl: UILabel!
    @IBOutlet weak var sureBtn: UIButton!
    @IBOutlet weak var topView: UIView!
    @IBOutlet weak var listView: UITableView!
    var tempArr:Array<GeneralInfoBrandModel>? = []
    var searchV : SearchBarView? = nil
    override func viewDidLoad() {
        super.viewDidLoad()
        if isSelectData {
            navbar.title = "请选择品牌"
            tableBottom.constant = CGFloat(TabHeight)
        }else{
            navbar.title = "品牌列表"
            navbar.rightTitle = "新增"
            sureBtn.isHidden = true
            sureLbl.isHidden = true
        }
        
        self.view.addSubview(navbar)
        SetTopFrame(view: topView, height: 44)
        listView.separatorStyle = .none
        
        let searchBr = SearchBarView.init()
        topView.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(10)
            make.right.equalTo(-10)
            make.centerY.equalToSuperview()
            make.height.equalTo(30)
        }
        searchV = searchBr
        searchBr.placeholderStr = "请输入品牌名称"
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        searchBr.delegateL = self
        tempArr = dataModelArray
        listView.register(UINib(nibName: "TitleAndSelectCell", bundle: nil), forCellReuseIdentifier: "TitleAndSelectCell")
        // Do any additional setup after loading the view.
    }
    func rightBtnClick() {
        let vc = XinZengPinPaiViewController()
        vc.navTitle = "新增品牌"
        self.navigationController?.pushViewController(vc, animated: true)
    }
    
    func clearSearchAction() {
        print("清楚搜索文字")
        dataModelArray?.removeAll()
        dataModelArray = tempArr
        listView.reloadData()
        
    }
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        
        searchBar.resignFirstResponder()
        if searchBar.text!.count > 0{
            dataModelArray?.removeAll()
            let str = searchBar.text
            for item in tempArr! {
                let strName = item.brand_name as! NSString
                if strName.contains(str!){
                    dataModelArray?.append(item)
                }
            }
        }
        listView.reloadData()
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 49
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return dataModelArray!.count
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndSelectCell") as! TitleAndSelectCell
        cell.delegate = self
        cell.tag = indexPath.row
        let rowModel = dataModelArray![indexPath.row]
        cell.titleLbl.text = rowModel.brand_name
        
        cell.titleLbl.textColor = UIColor(named: "标题字颜色")
        cell.selectBtn.isSelected = false
        if selectModel != nil {
            if rowModel.brand_id == selectModel?.brand_id {
                cell.titleLbl.textColor = UIColor(named: "蓝色字体颜色")
                cell.selectBtn.isSelected = true
            }
        }
        
        return cell
    }
    var selectModel : GeneralInfoBrandModel? = nil
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if isSelectData {
            let rowModel = dataModelArray![indexPath.row] as! GeneralInfoBrandModel
            selectModel = rowModel
            listView.reloadData()
        }else{
            let vc = XinZengPinPaiViewController()
            vc.navTitle = "编辑品牌"
            self.navigationController?.pushViewController(vc, animated: true)
        }
        
    }
    //MARK:--选择品牌确定按钮
    @IBAction func sureAction(_ sender: UIButton) {
        print("选择品牌确定按钮")
        if selectModel == nil {
            HUD.flash(.label("请选择品牌"), delay: 1.2)
        }else{
            self.delegate?.blackSelectPinPaiData(sender: selectModel!)
            self.navigationController?.popViewController(animated: true)
            
        }
    }
    //MARK:--自定义celldelegate
    func TitleAndSelectCellClick(content: UIButton, cell: TitleAndSelectCell) {
        print(cell.tag)
        let rowModel = dataModelArray![cell.tag] as! GeneralInfoBrandModel
        selectModel = rowModel
        listView.reloadData()
        
    }
    
}
