//
//  XinZengPinPaiViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/26.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton
import Photos

class XinZengPinPaiViewController: BaseViewController,UITableViewDataSource,UITableViewDelegate,TitleAndBtnCellDelegate,TitleAndTFCellDelegate,TilteAndTextViewCellDelegate{
    let titleArr = ["品牌名称","品牌图标","站点地址","品牌描述"]
    let holderArr = ["请输入品牌名称","0","请输入站点地址如：www.gelifood.com","0"]

    
    @IBOutlet weak var btnTitleLbl: UILabel!
    @IBOutlet weak var listView: UITableView!
    var logoIcon:UIImage?//图片
    var pinPaiName:String?//品牌名字
    var pinPaiUrl:String?//品牌连接
    var commend:String?//品牌描述
    
    var navTitle:String?
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = navTitle
        if navTitle == "编辑品牌" {
            navbar.rightTitle = "删除"
        }
        self.view.addSubview(navbar)
        SetTopFrameView(view: listView, btmView: btnTitleLbl)
        
        listView.separatorStyle = .none
        listView.isScrollEnabled = false
        listView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTF")
        listView.register(UINib(nibName: "TitleAndBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndBtn")
        listView.register(UINib(nibName: "TilteAndTextViewCell", bundle: nil), forCellReuseIdentifier: "TilteAndTextView")
        // Do any additional setup after loading the view.
    }
    //MARK: - 删除
    func rightBtnClick() {
        
    }
    //MARK: - 提交
    @IBAction func btnAction(_ sender: Any) {
        print("提交")
        print(pinPaiName)//名字
        print(pinPaiUrl)//链接
        print(commend)//描述
        print(logoIcon)//图片
    }
    //MARK: - cell delegate
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
           switch indexPath.row {
           case 0,2:
               let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTF") as! TitleAndTFCell
               cell.nameLbl.text = titleArr[indexPath.row]
               cell.textTF.placeholder = holderArr[indexPath.row]
               cell.delegate = self
               cell.tag = indexPath.row
               switch indexPath.row {
               case 0:
                cell.textTF.text = pinPaiName
                break
               case 2:
                cell.textTF.text = pinPaiUrl
                break
               default:
                break
               }
               return cell
           case 1:
               let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtn") as! TitleAndBtnCell
               cell.nameLbl.text = titleArr[indexPath.row]
               cell.contentLbl.text = "上传图片"
               cell.delegate = self
               if logoIcon != nil {
                   cell.imgView.image = logoIcon
                   cell.imgView.isHidden = false
                   cell.contentLbl.isHidden = true
               }
               return cell
           default:
               let cell = tableView.dequeueReusableCell(withIdentifier: "TilteAndTextView") as! TilteAndTextViewCell
               cell.titleLbl.text = titleArr[indexPath.row]
               cell.holderLbl.text = "简述品牌体征。"
               cell.textView.text = commend
               cell.delegate = self
               return cell
           }
    }
    func textFieldContent(content: String, cell: TitleAndTFCell) {
        if cell.tag == 0 {
        pinPaiName = content
        }
        pinPaiUrl = content
    }
    func TilteAndTextViewCellResponseStr(str: String, cell: TilteAndTextViewCell) {
        commend = str
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.row == 3 {
            return 173.5*glscale
        }
        if indexPath.row == 1 {
            if logoIcon != nil {
                return 100
            }
        }
        return 49*glscale
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return titleArr.count
    }
    func btnClick(content: String, cell: TitleAndBtnCell) {
        _ = self.presentHGImagePicker(maxSelected:1) { (assets) in
            //结果处理
            print("共选择了\(assets.count)张图片，分别如下：")
            let option = PHImageRequestOptions()
            option.isSynchronous = true
            option.isNetworkAccessAllowed = true
            for asset in assets {
                PHImageManager.default().requestImage(for: asset, targetSize: PHImageManagerMaximumSize , contentMode:  .default , options: option, resultHandler: { (image,  _: [AnyHashable : Any]?) in
                    //                    print("上传图片==\(image)")
                    self.logoIcon = image
                })
            }
            self.listView.reloadData()
        }
    }
   
}
