//
//  ChangeGoodsPriceVC.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/4/26.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import ViewAnimator
import LGButton
import IQKeyboardManagerSwift

protocol ChangeGoodsPriceVCDelegate {
    func changeGoodsPriByData(sender:Array<OrderDetailGoodsModel>)
}

class ChangeGoodsPriceVC: BaseViewController  , UITableViewDelegate, UITableViewDataSource,UITextFieldDelegate {
    var orderID:Int? = 0
    var delegate:ChangeGoodsPriceVCDelegate?
    var dataArr : Array<OrderDetailGoodsModel>? = []
     override func viewDidLoad() {
        super.viewDidLoad()
        
        navbar.title = "修改价格"
        self.view.addSubview(navbar)
        setTabv()
 
        
    }
    @IBOutlet weak var sureBtn: LGButton!
    //MARK:--确认修改价格
    @IBAction func sureAction(_ sender: LGButton) {
 
  
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        
        var order_goodsArr:Array<Any>? = []
        dataArr?.forEach({ (md) in
            var dic:[String:Any] = [:]
            dic.updateValue(md.og_id as Any, forKey: "og_id")
            dic.updateValue(md.cart_number as Any, forKey: "cart_number")
            dic.updateValue(md.goods_price as Any, forKey: "goods_price")
            dic.updateValue(md.is_edit as Any, forKey: "is_edit")
            order_goodsArr?.append(dic)
        })
        let order_goods = dataChangeString(sender: order_goodsArr!)

        editOrderGoodsPrice(["user_token":UserToken as Any,"order_id":orderID as Any,"order_goods":order_goods], success: { (data) in
            let dataM = data as! UpDataModel
            if dataM.code == 1 {
                self.delegate?.changeGoodsPriByData(sender: self.dataArr!)
                self.navigationController?.popViewController(animated: true)
            }

        }) { (error) in


        }
        
    }
    func textFieldDidEndEditing(_ textField: UITextField) {
        for i in 0..<dataArr!.count {
            if i == textField.tag {
                let md = dataArr![i]
                if isPurnNumber(str: textField.text!) {
                    md.goods_price = formatShowNumber(value: textField.text!)
                    //记录哪个更改了
                    md.is_edit = 1
                }
            }
        }
        
        self.tableV.reloadData()
    }
 
    
    var tableV :UITableView!
    
    private let animations = [AnimationType.from(direction: .bottom, offset: 150*glscale)]
    func setTabv() {
        tableV = UITableView()
        view.addSubview(tableV);
        tableV.snp.makeConstraints { (make) in
            make.left.right.equalToSuperview()
            make.top.equalTo(navbar.snp_bottom)
            make.bottom.equalTo(sureBtn.snp_top)
        }
        tableV.backgroundColor = UIColor.init(named: "白色背景色")
        tableV.delegate = self
        tableV.dataSource = self
        tableV.separatorStyle = .none
        tableV?.register(UINib(nibName: "ChangePriceNormalCell", bundle: nil), forCellReuseIdentifier: "ChangePriceNormalCell")
        
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        
//        return 20
        return dataArr!.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "ChangePriceNormalCell") as! ChangePriceNormalCell

        let rowModel = dataArr![indexPath.row]
        cell.goodsImgVire.sd_setImage(with: URL(string:SERVERCE_ImageHost +  rowModel.goods_thumb!))
        cell.goodsNameLbl.text = rowModel.goods_name
        if rowModel.goods_attr != nil {
            cell.attrrLbl.text = rowModel.goods_attr

        }else{
            cell.attrrLbl.text = "-"

        }
        cell.priceTf.text = rowModel.goods_price
        cell.detailLbl.isHidden = true
        cell.priceTf.delegate = self
        cell.priceTf.returnKeyType = .done
        cell.priceTf.keyboardType = .decimalPad
        cell.priceTf.tag = indexPath.row
        return cell
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        print(indexPath)
        
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 120*glscale
    }
    func scrollViewDidScroll(_ scrollView: UIScrollView) {
        IQKeyboardManager.shared.resignFirstResponder()
        //MARK:--滚动不修改数据
    }
}
