//
//  YDLBVc.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/10.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class YDLBVc: BaseViewController,UITableViewDelegate,UITableViewDataSource,UISearchBarDelegate,SearchBarViewDelegate,UITextFieldDelegate{
    
    @IBOutlet weak var contentView: UIView!
    @IBAction func listControlAction(_ sender: Any) {
        print("调用筛选列表")
        blackBtn.isHidden = !blackBtn.isHidden
        preView.isHidden = !preView.isHidden
    }
    
    
    @IBOutlet weak var preView: UIView!
    
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var searchVBg: UIView!
    @IBOutlet weak var topView: UIView!
    
    @IBOutlet weak var timeTF: UITextField!
    @IBOutlet weak var standerTF: UITextField!
    @IBOutlet weak var orderNumTF: UITextField!
    
    
    @IBOutlet weak var blackBtn: UIButton!
    @IBAction func closeAction(_ sender: UIButton) {
        preView.isHidden = !preView.isHidden
        blackBtn.isHidden = !blackBtn.isHidden
    }
    var searchV : SearchBarView? = nil
    var datas:Array<Any> = [1,2]
    
    var keyWord = ""
   
    override func viewDidLoad() {
        super.viewDidLoad()
        
        orderNumTF.tag = 1
        orderNumTF.delegate = self
        standerTF.delegate = self
       
        navbar.title = "运单列表"
        self.view.addSubview(navbar)
        SetTopFrame(view: topView, height: 51)
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "YunDanLieBiaoCell", bundle: nil), forCellReuseIdentifier: "YunDanLieBiaoCell")
        
        let searchBr = SearchBarView.init()
        searchVBg.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(10)
            make.right.equalTo(-10)
            make.centerY.equalToSuperview()
            make.height.equalTo(30)
        }
        searchV = searchBr
        searchBr.placeholderStr = "请输入运单号/收货人/发货人/地址"
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        searchBr.delegateL = self
        
        
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        self.listView!.mj_header = headerMJ
        self.listView.mj_header?.beginRefreshing()
        
    }
    func btnUISet(btn:UIButton){
        btn.isSelected = !btn.isSelected
        if btn.isSelected {
            btn.setTitleColor(UIColor.white, for: .normal)
            btn.backgroundColor = UIColor(named: "按钮背景颜色")
        }else{
            btn.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
            btn.backgroundColor = UIColor(named: "多选按钮背景颜色")
        }
    }
    @IBAction func btnClick(_ sender: UIButton) {
        if sender.titleLabel!.text != "重置" && sender.titleLabel!.text != "确定"{
            btnUISet(btn: sender)
        }
        switch sender.titleLabel?.text {
        case "京东":
            break
        case "已付款":
            break
        case "未付款":
            break
        case "已退款":
            break
        case "全部":
            if sender.tag == 99 {
                //运单状态
            }else{
                //打印状态
            }
            break
        case "已打印":
            break
        case "未打印":
            break
        case "下单完成":
            break
        case "揽收成功":
            break
        case "运输中":
            break
        case "已签收":
            break
        case "已取消":
            break
        case "重置":
            print("12")
            contentView.subviews.forEach { (item) in
                if item.isKind(of: UITextField.classForCoder()){
                    print("1")
                    let tf = item as! UITextField
                    tf.text = ""
                }
                if item.isKind(of: UIButton.classForCoder()){
                    print("2")
                    let btn = item as! UIButton
                    btn.isSelected = false
                    if btn.tag != 996 {
                        btn.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                        btn.backgroundColor = UIColor(named: "多选按钮背景颜色")
                    }
                }
            }
            break
        case "确定":
            preView.isHidden = true
            blackBtn.isHidden = true
            listView.mj_header?.beginRefreshing()
            break
        default:
            break
        }
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        let vc = XiaYunDanViewController()
        self.navigationController?.pushViewController(vc, animated: true)
    }
    
    @IBAction func timeSelectAction(_ sender: Any) {
        print("选择时间")
    }
    //MARK: - 加载数据
    @objc func loadData(){
        print("加载数据")
        removeBlackBtnView()
        self.listView.mj_header?.endRefreshing()
    }
    //MARK:--搜索模块
    //MAKR:--调起搜索后添加个蒙版本
    var blackBtnView:UIButton! = nil
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        preView.isHidden = true
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.left.right.bottom.equalToSuperview()
            make.top.equalTo(searchVBg.snp_bottom)
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        return true
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    
    //MARK:--搜索按钮代理
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索关键字进行--\(searchBar.text)")
        searchBar.resignFirstResponder()
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
        }
        
        keyWord = searchBar.text!
        listView.mj_header?.beginRefreshing()
    }
    
    //MARK:--清空搜索代理
    func clearSearchAction() {
        
    }
    //MARK:--编辑即将结束
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        removeBlackBtnView()
        if keyWord.count > 0 {
            keyWord = searchBar.text!
            if keyWord.count == 0 {
                listView.mj_header?.beginRefreshing()
            }
        }
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 227
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return datas.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "YunDanLieBiaoCell") as! YunDanLieBiaoCell
        cell.tag = indexPath.row
        return cell
    }
    func textFieldDidBeginEditing(_ textField: UITextField) {
        if textField.tag == 1 {
            orderNumTF.text = "   "
        }else{
            standerTF.text = "   "
        }
    }
    func textFieldDidEndEditing(_ textField: UITextField) {
        if textField.tag == 1 {
            orderNumTF.text = textField.text!
        }else{
            standerTF.text = textField.text!
        }
    }
    
}
